
; FASM SOURCE FILE
; http://flatassembler.net

; skyDSuiteDVB
; B2C2 DVB Monitor

; written by @L.CHEMIST (Andrey A. Meshkov)
; maalchemist@gmail.com
; maa-mail@yandex.ru

skyDSuiteDVB.CODE:

; ------------------------------------------------------------------------------

; -> eax = ASTATUS:HRESULT
proc SUCCEEDED

        mov     ecx, eax                        ; Save
        mov     edx, eax

        xor     eax, eax
        dec     eax                             ; Result = TRUE
;       not     eax                             ; Result = TRUE

        and     edx, 0x80000000
        test    edx, edx
        jz     .EXIT
        invoke  SetLastError, ecx
        xor     eax, eax                        ; Result = FALSE
   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; -> eax = ASTATUS:HRESULT
proc FAILED

        mov     ecx, eax                        ; Save
        mov     edx, eax

        xor     eax, eax                        ; Result = FALSE

        and     edx, 0x80000000
        test    edx, edx
        jz     .EXIT
        invoke  SetLastError, ecx
        xor     eax, eax
        dec     eax                             ; Result = TRUE
;       not     eax                             ; Result = TRUE
   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function TransportStreamCallback (APID: WORD; ATransportPacket: PByteArray): UINT; stdcall;
proc TransportStreamCallback, APID, ATransportPacket

        xor     eax, eax
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_Start (AInitData: Pointer; ADataSize: DWORD; AForce: BOOL): BOOL; stdcall;
proc B2C2_Start uses ebx esi edi, AInitData, ADataSize, AForce

    locals
       .P       dd ?
    endl

        xor     ebx, ebx
        invoke  SetLastError, ebx
        xor     eax, eax

        cmp     [AForce], eax
        jnz    .START
        dec     eax
;       not     eax
        cmp     [B2C2_Initialized], ebx
        jnz    .EXIT

   .START:
        stdcall B2C2_Stop

;       invoke  CoInitialize, NULL
        invoke  CoInitializeEx, NULL, COINIT_MULTITHREADED
        stdcall SUCCEEDED
        test    eax, eax
        jz     .EXIT

        inc     ebx ; EBX = 1

        invoke  CoCreateInstance, CLSID_B2C2MPEG2Filter, NULL, CLSCTX_INPROC, IID_IBaseFilter, B2C2_Filter
        stdcall SUCCEEDED
        test    eax, eax
        jz     .EXIT
        mov     [B2C2_Filter_Assigned], ebx

        cominvk B2C2_Filter, QueryInterface, IID_IB2C2MPEG2TunerCtrl4, B2C2_Tuner
        stdcall SUCCEEDED
        test    eax, eax
        jz     .EXIT
        mov     [B2C2_Tuner_Assigned], ebx

        cominvk B2C2_Filter, QueryInterface, IID_IB2C2MPEG2DataCtrl6, B2C2_Data
        stdcall SUCCEEDED
        test    eax, eax
        jz     .EXIT
        mov     [B2C2_Data_Assigned], ebx

        cominvk B2C2_Tuner, Initialize
        stdcall SUCCEEDED
        test    eax, eax
        jz     .EXIT

   .DEVICE:
        mov     esi, [AInitData]
        test    esi, esi
        jz     .DEVICE.OUT
        mov     ebx, [ADataSize]
        test    ebx, ebx
        jz     .DEVICE.OUT

        inc     ebx
        cinvoke calloc, ebx, 1
        test    eax, eax
        jz     .DEVICE.OUT
        mov     edi, eax

        dec     ebx
        cinvoke memcpy, edi, esi, ebx

        lea     eax, [.P]
        cinvoke strtoul, edi, eax, 10
        mov     ebx, eax
        cinvoke free, edi
        cmp     edi, [.P]
        je     .DEVICE.OUT

        cominvk B2C2_Data, SelectDevice, ebx
   .DEVICE.OUT:

        xor     eax, eax
        dec     eax
;       not     eax
        mov     [B2C2_Initialized], eax

   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_Stop (): BOOL; stdcall;
proc B2C2_Stop uses ebx

        xor     ebx, ebx
        invoke  SetLastError, ebx

        mov     [B2C2_Initialized], ebx

        stdcall B2C2_DelFilter, 0

        cmp     [B2C2_Data_Assigned], ebx
        jz      @F
        mov     [B2C2_Data_Assigned], ebx
        cominvk B2C2_Data, Release
    @@:

        cmp     [B2C2_Tuner_Assigned], ebx
        jz      @F
        mov     [B2C2_Tuner_Assigned], ebx
        cominvk B2C2_Tuner, Release
    @@:

        cmp     [B2C2_Filter_Assigned], ebx
        jz      @F
        mov     [B2C2_Filter_Assigned], ebx
        cominvk B2C2_Filter, Release
    @@:

;       cmp     [MediaControl_Assigned], ebx
;       jz      @F
;       mov     [MediaControl_Assigned], ebx
;       cominvk MediaControl, Release
;   @@:

;       cmp     [FilterGraph_Assigned], ebx
;       jz      @F
;       mov     [FilterGraph_Assigned], ebx
;       cominvk FilterGraph, Release
;   @@:

        invoke  CoUninitialize

        xor     eax, eax
        dec     eax
;       not     eax
   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_SendDiSEqC (ADiSEqCType: DWORD; AData: BYTE): BOOL; stdcall;
proc B2C2_SendDiSEqC, ADiSEqCType, AData

        invoke  SetLastError, 1 ; ERROR_INVALID_FUNCTION
        xor     eax, eax
   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_SendDiSEqCmd (ACmd: PBYTE; ALength: DWORD): BOOL; stdcall;
proc B2C2_SendDiSEqCmd, ACmd, ALength

        invoke  SetLastError, 1 ; ERROR_INVALID_FUNCTION
        xor     eax, eax
   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_SetChannel (AFrequency, ASymbolRate, APolarity, AFEC, ALOF1, ALOF2, ALOFSwitch: DWORD): BOOL; stdcall;
proc _B2C2_SetChannel uses ebx, AFrequency, ASymbolRate, APolarity, AFEC, ALOF1, ALOF2, ALOFSwitch

    locals
       .P       DWORD ?
    endl

        xor     eax, eax
        lea     ebx, [.P]

        cmp     [B2C2_Tuner_Assigned], eax
        jz     .EXIT

        cominvk B2C2_Tuner, GetFrequency, ebx
        stdcall SUCCEEDED
        test    eax, eax
        jz      @F
        cominvk B2C2_Tuner, SetFrequency, [.P]
    @@:

        cominvk B2C2_Tuner, GetSymbolRate, ebx
        stdcall SUCCEEDED
        test    eax, eax
        jz      @F
        cominvk B2C2_Tuner, SetSymbolRate, [.P]
    @@:

        cominvk B2C2_Tuner, GetPolarity, ebx
        stdcall SUCCEEDED
        test    eax, eax
        jz      @F
        cominvk B2C2_Tuner, SetPolarity, [.P]
    @@:

        cominvk B2C2_Tuner, GetFec, ebx
        stdcall SUCCEEDED
        test    eax, eax
        jz      @F
        cominvk B2C2_Tuner, SetFec, [.P]
    @@:

        cominvk B2C2_Tuner, GetLnbFrequency, ebx
        stdcall SUCCEEDED
        test    eax, eax
        jz      @F
        cominvk B2C2_Tuner, SetLnbFrequency, [.P]
    @@:

;       cominvk B2C2_Tuner, GetModulation, ebx
;       stdcall SUCCEEDED
;       test    eax, eax
;       jz      @F
;       cominvk B2C2_Tuner, SetModulation, [.P]
;   @@:

        cominvk B2C2_Tuner, SetTunerStatus
        stdcall SUCCEEDED

   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_SetChannel (AFrequency, ASymbolRate, APolarity, AFEC, ALOF1, ALOF2, ALOFSwitch: DWORD): BOOL; stdcall;
proc B2C2_SetChannel, AFrequency, ASymbolRate, APolarity, AFEC, ALOF1, ALOF2, ALOFSwitch

        invoke  SetLastError, 1 ; ERROR_INVALID_FUNCTION
        xor     eax, eax
   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_SetChannelEx (AFrequency, ASymbolRate, APolarity, AFEC, ALOF1, ALOF2, ALOFSwitch, AModulation: DWORD): BOOL; stdcall;
proc _B2C2_SetChannelEx uses ebx, AFrequency, ASymbolRate, APolarity, AFEC, ALOF1, ALOF2, ALOFSwitch, AModulation

    locals
       .P       DWORD ?
    endl

        xor     eax, eax
        lea     ebx, [.P]

        cmp     [B2C2_Tuner_Assigned], eax
        jz     .EXIT

        cominvk B2C2_Tuner, GetFrequency, ebx
        stdcall SUCCEEDED
        test    eax, eax
        jz      @F
        cominvk B2C2_Tuner, SetFrequency, [.P]
    @@:

        cominvk B2C2_Tuner, GetSymbolRate, ebx
        stdcall SUCCEEDED
        test    eax, eax
        jz      @F
        cominvk B2C2_Tuner, SetSymbolRate, [.P]
    @@:

        cominvk B2C2_Tuner, GetPolarity, ebx
        stdcall SUCCEEDED
        test    eax, eax
        jz      @F
        cominvk B2C2_Tuner, SetPolarity, [.P]
    @@:

        cominvk B2C2_Tuner, GetFec, ebx
        stdcall SUCCEEDED
        test    eax, eax
        jz      @F
        cominvk B2C2_Tuner, SetFec, [.P]
    @@:

        cominvk B2C2_Tuner, GetLnbFrequency, ebx
        stdcall SUCCEEDED
        test    eax, eax
        jz      @F
        cominvk B2C2_Tuner, SetLnbFrequency, [.P]
    @@:

        cominvk B2C2_Tuner, GetModulation, ebx
        stdcall SUCCEEDED
        test    eax, eax
        jz      @F
        cominvk B2C2_Tuner, SetModulation, [.P]
    @@:

        cominvk B2C2_Tuner, SetTunerStatus
        stdcall SUCCEEDED

   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_SetChannelEx (AFrequency, ASymbolRate, APolarity, AFEC, ALOF1, ALOF2, ALOFSwitch, AModulation: DWORD): BOOL; stdcall;
proc B2C2_SetChannelEx uses ebx, AFrequency, ASymbolRate, APolarity, AFEC, ALOF1, ALOF2, ALOFSwitch, AModulation

        invoke  SetLastError, 1 ; ERROR_INVALID_FUNCTION
        xor     eax, eax
   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_SetFilter (APID: WORD; ACallback: Pointer; ACallBackType: DWORD; ASize: DWORD; var AFilterID: DWORD): BOOL; stdcall;
proc _B2C2_SetFilter uses ebx, APID, ACallback, ACallBackType, ASize, AFilterID

        xor     eax, eax
        xor     ebx, ebx

        mov     edx, [AFilterID]
        mov     dword [edx], 0xB2C2
;       mov     [edx], ebx

        cmp     [B2C2_Data_Assigned], ebx
        jz     .EXIT

   .TS:
        cmp     [B2C2_TSCaBa], ebx
        jnz    .TS.OUT ; skip :: already assigned
        mov     edx, [ACallback]
        cmp     edx, ebx
        jz     .TS.OUT ; skip :: empty ACallback parameter
        mov     [B2C2_TSCaBa], edx
        cominvk B2C2_Data, SetCallbackForTransportStream, edx
        stdcall SUCCEEDED
        test    eax, eax
        jz     .EXIT
   .TS.OUT:

   .PIDs:
        cmp     [B2C2_TSPIDs], ebx
        jnz    .PIDs.OUT ; skip :: already assigned
        xor     edx, edx
        mov     dx, word [APID]
        cmp     edx, ebx
        jz     .PIDs.OUT ; skip :: empty APID parameter
        mov     [B2C2_TSPIDs], edx
        cominvk B2C2_Data, AddTsPIDs, 1, B2C2_TSPIDs
        stdcall SUCCEEDED
        test    eax, eax
        jz     .EXIT
   .PIDs.OUT:

        xor     eax, eax
        inc     eax
   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_SetFilter (APID: WORD; AFunc: Pointer; ACallBackType: DWORD; ASize: DWORD; var AFilterID: DWORD): BOOL; stdcall;
proc B2C2_SetFilter, APID, AFunc, ACallBackType, ASize, AFilterID

        invoke  SetLastError, 1 ; ERROR_INVALID_FUNCTION
        xor     eax, eax
   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_DelFilter (AFilterID: DWORD): BOOL; stdcall;
proc _B2C2_DelFilter uses ebx, AFilterID

        xor     eax, eax
        xor     ebx, ebx

        cmp     [B2C2_Data_Assigned], ebx
        jz     .EXIT

   .PIDs:
        cmp     [B2C2_TSPIDs], ebx
        jz     .PIDs.OUT ; skip :: already unassigned
        cominvk B2C2_Data, DeleteTsPIDs, 1, B2C2_TSPIDs
        mov     [B2C2_TSPIDs], ebx
   .PIDs.OUT:

   .TS:
        cmp     [B2C2_TSCaBa], ebx
        jz     .TS.OUT ; skip :: already unassigned
        cominvk B2C2_Data, SetCallbackForTransportStream, ebx
        mov     [B2C2_TSCaBa], ebx
   .TS.OUT:

        xor     eax, eax
        inc     eax
   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_DelFilter (AFilterID: DWORD): BOOL; stdcall;
proc B2C2_DelFilter, AFilterID

        invoke  SetLastError, 1 ; ERROR_INVALID_FUNCTION
        xor     eax, eax
   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_TunerInLock (): BOOL; stdcall;
proc B2C2_TunerInLock

        xor     eax, eax
        cmp     [B2C2_Initialized], eax
        jz     .EXIT

        cominvk B2C2_Tuner, CheckLock
        stdcall SUCCEEDED

   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; procedure B2C2_ClearStatus (var ATunerStatus: TDVB_TunerStatus); stdcall;
proc _B2C2_ClearStatus uses ebx, ATunerStatus

        mov     ebx, [ATunerStatus]
        test    ebx, ebx
        jz     .EXIT

        cinvoke memset, ebx, 0xFFFFFFFF, sizeof.TDVB_TunerStatus

        lea     eax, [ebx + TDVB_TunerStatus.TunerType]
        mov     [eax], BYTE 0

        mov     eax, [FLOAT_m1]
        mov     [ebx + TDVB_TunerStatus.SNR], eax
        mov     [ebx + TDVB_TunerStatus.BER], eax
   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; procedure B2C2_ClearStatus (var ATunerStatus: TDVB_TunerStatus); stdcall;
proc B2C2_ClearStatus uses ebx, ATunerStatus

        mov     ebx, [ATunerStatus]
        test    ebx, ebx
        jz     .EXIT

        xor     eax, eax

        lea     edx, [ebx + TDVB_TunerStatus.TunerType]
        mov     [edx], al

        dec     eax ; EAX=-1

        mov     [ebx + TDVB_TunerStatus.Signal.Locked], eax
        mov     [ebx + TDVB_TunerStatus.Signal.Quality], eax
        mov     [ebx + TDVB_TunerStatus.Signal.Present], eax
        mov     [ebx + TDVB_TunerStatus.Signal.Strength], eax
        mov     [ebx + TDVB_TunerStatus.PIDsCount], eax

        mov     edx, [FLOAT_m1]
        mov     [ebx + TDVB_TunerStatus.SNR], edx
        mov     [ebx + TDVB_TunerStatus.BER], edx
   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_GetStatus (var ATunerStatus: TDVB_TunerStatus): BOOL; stdcall;
proc B2C2_GetStatus uses ebx esi edi, ATunerStatus

    locals
       .V       dd ?
       .CAPS    TB2C2_TunerCapabilities
       .SIZE    dd ?
       .PIDsC   dd ?
       .PIDs    TDVB_PIDs
       .RESULT  dd ?
    endl

        xor     eax, eax
        mov     [.RESULT], eax ; RESULT = FALSE
        invoke  SetLastError, eax

        mov     edx, [ATunerStatus]
        test    edx, edx
        jz     .EXIT

        stdcall B2C2_ClearStatus, edx

        cmp     [B2C2_Initialized], 0
        jz     .EXIT

        lea     edi, [.CAPS]

        mov     [.SIZE], sizeof.TB2C2_TunerCapabilities
        lea     ecx, [.SIZE]
        cominvk B2C2_Tuner, GetTunerCapabilities, edi, ecx
        stdcall SUCCEEDED
        test    eax, eax
        jz     .EXIT ; return on error

        mov     ebx, [ATunerStatus]

        lea     eax, [ebx + TDVB_TunerStatus.TunerType]
        cinvoke memcpy, eax, SC_B2C2, SC_B2C2.size

        mov     esi, [edi + TB2C2_TunerCapabilities.dwPerformanceMonitoring]
        lea     edi, [.V]

   .Signal.Quality:
        mov     eax, esi
        and     eax, SIGNAL_QUALITY_SUPPORTED
        test    eax, eax
        jz     .Signal.Quality.OUT ; skip on no support

        cominvk B2C2_Tuner, GetSignalQuality, edi
        stdcall SUCCEEDED
        test    eax, eax
        jz     .Signal.Quality.OUT ; skip on error

        mov     eax, [edi]
        mov     [ebx + TDVB_TunerStatus.Signal.Quality], eax
   .Signal.Quality.OUT:

   .Signal.Locked:
        xor     eax, eax
        mov     [ebx + TDVB_TunerStatus.Signal.Locked], eax

        cominvk B2C2_Tuner, CheckLock
        stdcall SUCCEEDED
        test    eax, eax
        jz     .Signal.Locked.OUT

        inc     [ebx + TDVB_TunerStatus.Signal.Locked]
   .Signal.Locked.OUT:

   .Signal.Strength:
        mov     eax, esi
        and     eax, SIGNAL_STRENGTH_SUPPORTED
        test    eax, eax
        jz     .Signal.Strength.OUT ; skip on no support

        cominvk B2C2_Tuner, GetSignalStrength, edi
        stdcall SUCCEEDED
        test    eax, eax
        jz     .Signal.Strength.OUT ; skip on error

        mov     eax, [edi]
        mov     [ebx + TDVB_TunerStatus.Signal.Strength], eax
   .Signal.Strength.OUT:

   .Signal.Present:
        xor     eax, eax
        mov     [ebx + TDVB_TunerStatus.Signal.Present], eax

        mov     eax, [ebx + TDVB_TunerStatus.Signal.Strength]
        cmp     eax, 0
        jle    .Signal.Present.OUT

        inc     [ebx + TDVB_TunerStatus.Signal.Present]
   .Signal.Present.OUT:

   .SNR:
        mov     eax, esi
        and     eax, SNR_SUPPORTED
        test    eax, eax
        jz     .SNR.OUT ; skip on no support

        cominvk B2C2_Tuner, GetSNR, edi
        stdcall SUCCEEDED
        test    eax, eax
        jz     .SNR.OUT ; skip on error

        mov     eax, [edi]
        mov     [ebx + TDVB_TunerStatus.SNR], eax
   .SNR.OUT:

   .BER:
        mov     eax, esi
        and     eax, BER_SUPPORTED
        test    eax, eax
        jz     .BER.OUT ; skip on no support

        cominvk B2C2_Tuner, GetPreErrorCorrectionBER, edi
        stdcall SUCCEEDED
        test    eax, eax
        jz     .BER.OUT ; skip on error

        mov     eax, [edi]
        mov     [ebx + TDVB_TunerStatus.BER], eax
   .BER.OUT:

   .PID:
        mov     [.PIDsC], MAX_REASONABLE_SUPPORTED_PIDS
        lea     edi, [.PIDsC]
        lea     esi, [.PIDs]
        cominvk B2C2_Data, GetIpPIDs, edi, esi
        stdcall SUCCEEDED
        test    eax, eax
        jz     .PID.OUT ; skip on error

        mov     eax, [.PIDsC]
        mov     [ebx + TDVB_TunerStatus.PIDsCount], eax
        test    eax, eax
        jz     .PID.OUT

        mov     ecx, sizeof.TDVB_PID
        mul     ecx
        lea     edi, [ebx + TDVB_TunerStatus.PIDs]
        cinvoke memcpy, edi, esi, eax
   .PID.OUT:

        dec     [.RESULT] ; RESULT = TRUE
;       not     [.RESULT] ; RESULT = TRUE
   .EXIT:
        mov     eax, [.RESULT]
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_GetMAC (var AMAC: TDVB_MAC): BOOL; stdcall;
proc B2C2_GetMAC, AMAC

        invoke  SetLastError, 0
        xor     eax, eax

        cmp     [B2C2_Initialized], eax
        jz     .EXIT

        mov     edx, [AMAC]
        test    edx, edx
        jz     .EXIT

        cominvk B2C2_Data, GetHardwareMacAddress, edx
        stdcall SUCCEEDED
   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_GetUCMAC (var AMAC: TDVB_MAC): BOOL; stdcall;
proc B2C2_GetUCMAC, AMAC

        invoke  SetLastError, 0
        xor     eax, eax

        cmp     [B2C2_Initialized], eax
        jz     .EXIT

        mov     edx, [AMAC]
        test    edx, edx
        jz     .EXIT

        cominvk B2C2_Data, GetUnicastMacAddress, edx
        stdcall SUCCEEDED
   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_SetUCMAC (var AMAC: TDVB_MAC): BOOL; stdcall;
proc B2C2_SetUCMAC, AMAC

        invoke  SetLastError, 0
        xor     eax, eax

        cmp     [B2C2_Initialized], eax
        jz     .EXIT

        mov     edx, [AMAC]
        test    edx, edx
        jz     .EXIT

        cominvk B2C2_Data, SetUnicastMacAddress, edx
        stdcall SUCCEEDED
   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_GetMCMAC (var AMACs: TDVB_MACs): BOOL; stdcall;
proc B2C2_GetMCMAC uses ebx, AMACs

        invoke  SetLastError, 0
        xor     eax, eax

        cmp     [B2C2_Initialized], eax
        jz     .EXIT

        mov     ebx, [AMACs]
        test    ebx, ebx
        jz     .EXIT

        cinvoke memset, ebx, 0, sizeof.TDVB_MACs
        mov     [ebx + TDVB_MACs.Count], MAC_ADDR_LIST_MAX

        cominvk B2C2_Data, GetMulticastMacAddressList, ebx
        stdcall SUCCEEDED
   .EXIT:
        ret
endp

; ------------------------------------------------------------------------------

; function B2C2_SetPIDs (var APIDs: TDVB_PIDs; var APIDsCount: Integer): BOOL; stdcall;
proc B2C2_SetPIDs uses ebx esi edi, APIDs, APIDsCount

    locals
       .PIDsC   dd ?
       .PIDs    TDVB_PIDs
       .RESULT  dd ?
    endl

        xor     eax, eax
        mov     [.RESULT], eax ; RESULT = FALSE
        invoke  SetLastError, eax

        mov     ebx, [APIDs]
        test    ebx, ebx
        jz     .EXIT

        mov     ecx, [APIDsCount]
        test    ecx, ecx
        jz     .EXIT

        mov     ecx, [ecx]
        cmp     ecx, 0
        jle    .EXIT
        cmp     ecx, MAX_REASONABLE_SUPPORTED_PIDS
        jg     .EXIT

        lea     edi, [.PIDsC]
        lea     esi, [.PIDs]
        mov     [.PIDsC], MAX_REASONABLE_SUPPORTED_PIDS
        cominvk B2C2_Data, GetIpPIDs, edi, esi
        stdcall SUCCEEDED
        test    eax, eax
        jz     .EXIT

        cominvk B2C2_Data, DeleteIpPIDs, [.PIDsC], esi
        stdcall SUCCEEDED
        test    eax, eax
        jz     .EXIT

        mov     ecx, [APIDsCount]
        mov     ecx, [ecx]
        cominvk B2C2_Data, AddIpPIDs, ecx, ebx
        stdcall SUCCEEDED
        test    eax, eax
        jz     .EXIT

        mov     ecx, [APIDsCount]
        mov     [ecx], DWORD MAX_REASONABLE_SUPPORTED_PIDS
        cominvk B2C2_Data, GetIpPIDs, ecx, ebx
        stdcall SUCCEEDED
        test    eax, eax
        jz     .EXIT

        dec     [.RESULT] ; RESULT = TRUE
;       not     [.RESULT] ; RESULT = TRUE
   .EXIT:
        mov     eax, [.RESULT]
        ret
endp

; ------------------------------------------------------------------------------
