
; FASM SOURCE FILE
; http://flatassembler.net

; skyDSuiteDVB
; B2C2 DVB Monitor

; written by @L.CHEMIST (Andrey A. Meshkov)
; maalchemist@gmail.com
; maa-mail@yandex.ru

; ------------------------------------------------------------------------------

COINIT_MULTITHREADED          = 0 ; OLE calls objects on any thread.
COINIT_APARTMENTTHREADED      = 2 ; Apartment model
COINIT_DISABLE_OLE1DDE        = 4 ; Dont use DDE for Ole1 support.
COINIT_SPEED_OVER_MEMORY      = 8 ; Trade memory for speed.

CLSCTX_INPROC_SERVER          = 0x1
CLSCTX_INPROC_HANDLER         = 0x2
CLSCTX_LOCAL_SERVER           = 0x4
CLSCTX_INPROC_SERVER16        = 0x8
CLSCTX_REMOTE_SERVER          = 0x10
CLSCTX_INPROC_HANDLER16       = 0x20
CLSCTX_RESERVED1              = 0x40
CLSCTX_RESERVED2              = 0x80
CLSCTX_RESERVED3              = 0x100
CLSCTX_RESERVED4              = 0x200
CLSCTX_NO_CODE_DOWNLOAD       = 0x400
CLSCTX_RESERVED5              = 0x800
CLSCTX_NO_CUSTOM_MARSHAL      = 0x1000
CLSCTX_ENABLE_CODE_DOWNLOAD   = 0x2000
CLSCTX_NO_FAILURE_LOG         = 0x4000
CLSCTX_DISABLE_AAA            = 0x8000
CLSCTX_ENABLE_AAA             = 0x10000
CLSCTX_FROM_DEFAULT_CONTEXT   = 0x20000
CLSCTX_ACTIVATE_32_BIT_SERVER = 0x40000
CLSCTX_ACTIVATE_64_BIT_SERVER = 0x80000
CLSCTX_ENABLE_CLOAKING        = 0x100000
CLSCTX_PS_DLL                 = 0x80000000

CLSCTX_INPROC                 = CLSCTX_INPROC_SERVER or CLSCTX_INPROC_HANDLER

; ------------------------------------------------------------------------------

struc T_STR S
{
 .s db S,0
 .size=$-.s
}

; ------------------------------------------------------------------------------

struct TDVB_STR64
    CHAR 64 dup (?)
ends
TYPEDEF PDVB_STR64, PVOID

; ------------------------------------------------------------------------------

MAC_ADDR_SIZE                 = B2C2_SDK_MAC_ADDR_SIZE;
MAC_ADDR_LIST_MAX             = B2C2_SDK_MAC_ADDR_LIST_MAX;
MAX_REASONABLE_SUPPORTED_PIDS = 64

; ------------------------------------------------------------------------------

struct TDVB_MAC
    BYTE MAC_ADDR_SIZE dup (?)
ends
TYPEDEF PDVB_MAC, PVOID

struct TDVB_MAC_LIST
    BYTE MAC_ADDR_LIST_MAX * MAC_ADDR_SIZE dup (?)
ends
TYPEDEF PDVB_MAC_LIST, PVOID

struct TDVB_MACs
    Count INT ?         ; input/output
    List  TDVB_MAC_LIST ; output
ends
TYPEDEF PDVB_MACs, PVOID

; ------------------------------------------------------------------------------

TYPEDEF TDVB_PID, INT
struct TDVB_PIDs
    TDVB_PID MAX_REASONABLE_SUPPORTED_PIDS dup (?)
ends
TYPEDEF PDVB_PIDs, PVOID

; ------------------------------------------------------------------------------
;    INT  FLOAT   
struct TDVB_TunerSignal
    Locked   INT ? ; // Signal Locked
    Quality  INT ? ; // Signal Quality
    Present  INT ? ; // Signal Present
    Strength INT ? ; // Signal Strength
ends
TYPEDEF PDVB_TunerSignal, PVOID

; ------------------------------------------------------------------------------

;    INT  FLOAT   
struct TDVB_TunerStatus
    TunerType TDVB_STR64       ; // Tuner Type

    Signal    TDVB_TunerSignal ; // Signal Data
    SNR       FLOAT ?          ; // Signal To Noise Ratio
    BER       FLOAT ?          ; // Bit Error Rate

    PIDsCount INT ?            ; // IP PIDs Count
    PIDs      TDVB_PIDs        ; // IP PIDs Array
ends
TYPEDEF PDVB_TunerStatus, PVOID

; ------------------------------------------------------------------------------
